//============================================================================
// Name        : DU2.cpp
// Author      : Vikturek
// Version     : 0.2
// Copyright   : None
// Description : Education homework for PJC 2011, in C++, Ansi-style
//============================================================================

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cstdlib>
#include <time.h>

// Zdrojovy kod s vasi implementaci BSTSET
#include "BSTSET.h"

using namespace std;

void printUsage(){
	cout << "\nUsage for DU4 application:\n\n";
	cout << "\tDU4 commandFile [--time-measure]\n\n";
}

// Funkce zalozi instanci objektu BSTSET a vlozi do ni hodnoty ze vstupniho souboru
template <class Type> void test(ifstream &commandFile){
	BSTSET<Type> *bsTree = new BSTSET<Type>;
	BSTSET<Type> &b = *bsTree;
	Type i;
	string line;
	stringstream lineStream;

	while(!commandFile.eof()){
		getline(commandFile, line);
		lineStream.clear();
		if(line.size() < 3){
			continue;
		}
		lineStream << line.substr(3);
		lineStream >> i;
		if(line.substr(0,3) == string("ADD")){
			cout << "ADD " << i << endl;
			if(!lineStream.fail()){
				// Vlozi hodnotu do mnoziny
				b << i;
				// Zjisti jak hluboko je dany prvek vlozen v BST
				cout << "b[" << i << "] == " << b[i] << endl;
				// Zjisti kolikrat byla hodnota do mnoziny vlozena
				cout << "b(" << i << ") == " << b(i) << endl;
				continue;
			}
		} else if(line.substr(0,3) == string("DEL")){
			cout << "DEL " << i << endl;
			if(!lineStream.fail()){
				// Vyjme hodnotu z mnoziny
				b >> i;
				// Zjisti jak hluboko je dany prvek vlozen v BST
				cout << "b[" << i << "] == " << b[i] << endl;
				// Zjisti kolikrat byla hodnota do mnoziny vlozena
				cout << "b(" << i << ") == " << b(i) << endl;
				continue;
			}
		}
		cout << "Omitting input line!" << endl;
	}
	// Jsme v sablone funkce, proto musime pro pristup k iteratoru pouzit klicove
	// slovo typename. Mimo sablonu by to nebylo potreba!
	for(typename BSTSET<Type>::iterator i = b.begin(); i != b.end(); i++){
		cout << (*i) << endl;
	}
	delete bsTree;
}

int main(int argc, char **argv) {
	ifstream commandFile;
	string line;
	stringstream lineStream(line);
	clock_t startTime = clock();
	bool timeMeasuring = false;

	if(argc >= 2){
		// Ocekava jeden argument z prikazove radky - prikazovy soubor.
		commandFile.open(argv[1]);
		if(!commandFile.is_open()){
			printUsage();
			return -1;
		}
		if(argc == 3){
			// Ocekava navic jeste jeden parametr --time-measure, kterym se zapina
			// zobrazeni doby trvani chodu aplikace.
			if(string(argv[2]) != "--time-measure"){
				printUsage();
				return -1;
			} else {
				timeMeasuring = true;
			}
		}
	} else {
		printUsage();
		return -1;
	}
	getline(commandFile, line);
	if(line == string("INT")){
		test<int>(commandFile);
	} else if (line == string("DOUBLE")){
		test<double>(commandFile);
	} else if (line == string("STRING")){
		test<string>(commandFile);
	}
	if(timeMeasuring){
		cerr << endl << "Delka behu aplikace: \n\n" << ((double) clock() - startTime) / CLOCKS_PER_SEC << endl;
	}
	return 0;
}

